HDU 1240 Asteroids! (三维BFS)

Asteroids!

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 4749    Accepted Submission(s): 3048

Problem Description

You‘re in space.

You want to get home.

There are asteroids.

You don‘t want to hit them.

Input

Input to this problem will consist of a (non-empty) series of up to 100 data sets. Each data set will be formatted according to the following description, and there will be no blank lines separating data sets.

A single data set has 5 components:

Start line - A single line, "START N", where 1 <= N <= 10.

Slice list - A series of N slices. Each slice is an N x N matrix representing a horizontal slice through the asteroid field. Each position in the matrix will be one of two values:

‘O‘ - (the letter "oh") Empty space

‘X‘ - (upper-case) Asteroid present

Starting Position - A single line, "A B C", denoting the <A,B,C> coordinates of your craft‘s starting position. The coordinate values will be integers separated by individual spaces.

Target Position - A single line, "D E F", denoting the <D,E,F> coordinates of your target‘s position. The coordinate values will be integers separated by individual spaces.

End line - A single line, "END"

The origin of the coordinate system is <0,0,0>. Therefore, each component of each coordinate vector will be an integer between 0 and N-1, inclusive.

The first coordinate in a set indicates the column. Left column = 0.

The second coordinate in a set indicates the row. Top row = 0.

The third coordinate in a set indicates the slice. First slice = 0.

Both the Starting Position and the Target Position will be in empty space.

Output

For each data set, there will be exactly one output set, and there will be no blank lines separating output sets.

A single output set consists of a single line. If a route exists, the line will be in the format "X Y", where X is the same as N from the corresponding input data set and Y is the least number of moves necessary to get your ship from the starting position to
the target position. If there is no route from the starting position to the target position, the line will be "NO ROUTE" instead.

A move can only be in one of the six basic directions: up, down, left, right, forward, back. Phrased more precisely, a move will either increment or decrement a single component of your current position vector by 1.

Sample Input

START 1
O
0 0 0
0 0 0
END
START 3
XXX
XXX
XXX
OOO
OOO
OOO
XXX
XXX
XXX
0 0 1
2 2 1
END
START 5
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
XXXXX
XXXXX
XXXXX
XXXXX
XXXXX
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
0 0 0
4 4 4
END

Sample Output

1 0
3 4
NO ROUTE

Source

South Central USA 2001

Recommend

zf

原题链接:

http://acm.hdu.edu.cn/showproblem.php?pid=1240

题意:输入n,代表n*n*n的区域,下面有n个n*n的矩阵,代表每一层的情况,接下来输入起点和终点的坐标,如    果存在最短路径,输出n和最短路径的长度,不存在输出“NO ROUTE”;

简单BFS。三维注意坐标的含义!!

AC代码:

#include <iostream>
#include <cstring>
#include <queue>
#include <cstdio>
using namespace std;
char a[15][15][15];
bool vis[15][15][15];
int n;
char ch[10];
int ans;
int sx,sy,sz,ex,ey,ez;
int dir[6][3]= {0,1,0,
                1,0,0,
                -1,0,0,
                0,-1,0,
                0,0,1,
                0,0,-1
               };
struct node
{
    int x,y,z,t;
};
bool OK(node no)
{
    if(no.x<0||no.x>=n||no.y<0||no.y>=n||no.z<0||no.z>=n)
        return false;
    return true;
}
int BFS()
{
    node now,next;
    queue<node>q;
    memset(vis,false,sizeof(vis));
    vis[sz][sx][sy]=true;
    now.x=sx;
    now.y=sy;
    now.z=sz;
    now.t=0;
    q.push(now);
    while(!q.empty())
    {
        now=q.front();
        q.pop();
        if(now.x==ex&&now.y==ey&&now.z==ez)
        {
            return now.t;
        }
        //cout<<"********************"<<endl;
        for(int i=0; i<6; i++)
        {
            next.x=now.x+dir[i][0];
            next.y=now.y+dir[i][1];
            next.z=now.z+dir[i][2];
            //cout<<"x="<<next.x<<",y="<<next.y<<",z="<<next.z<<endl;
            if(OK(next)&&!vis[next.z][next.x][next.y]&&a[next.z][next.x][next.y]!='X')
            {
                vis[next.z][next.x][next.y]=true;
                next.t=now.t+1;
                //cout<<"----------------------------x="<<next.x<<",y="<<next.y<<",z="<<next.z<<endl;
                q.push(next);
            }
        }
    }
    return -1;
}

int main()
{
    while(scanf("%s%d",ch,&n)!=EOF)
    {
        getchar();
        for(int i=0; i<n; i++)
        {
            for(int j=0; j<n; j++)
            {
                for(int k=0; k<n; k++)
                    scanf("%c",&a[i][j][k]);
                getchar();
            }

        }
        cin>>sy>>sx>>sz;
        cin>>ey>>ex>>ez;
        cin>>ch;
        ans=BFS();
        if(ans!=-1)
            cout<<n<<" "<<ans<<endl;
        else
            cout<<"NO ROUTE"<<endl;
    }
    return 0;
}
时间: 2024-07-29 20:42:10

HDU 1240 Asteroids! (三维BFS)的相关文章

HDU 1240 Asteroids!【BFS】

题意:给出一个三维的空间,给出起点和终点,问是否能够到达终点 和上一题一样,只不过这一题的坐标是zxy输入的, 因为题目中说的是接下来的n行中分别是由n*n的矩形组成的,所以第一个n该是Z坐标,n*n的矩形为底面,为x,y坐标 -----还是注意输入的方式--- #include<iostream> #include<cstdio> #include<cstring> #include<algorithm> #include<queue> #de

hdu 1240:Asteroids!(三维BFS搜索)

Asteroids! Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 3159    Accepted Submission(s): 2106 Problem Description You're in space.You want to get home.There are asteroids.You don't want to hit

HDU 1240——Asteroids!(三维BFS)POJ 2225——Asteroids

普通的三维广搜,需要注意的是输入:列,行,层 #include<iostream> #include<cstdio> #include<cstring> #include<queue> #include<algorithm> #define M 11 using namespace std; int dir[6][3]={{0,1,0},{0,-1,0},{1,0,0},{-1,0,0},{0,0,1},{0,0,-1}};//6个方向 int

HDU 1240 (简单三维广搜) Asteroids!

给出一个三维的迷宫以及起点和终点,求能否到大终点,若果能输出最短步数 三维的问题无非就是变成了6个搜索方向 最后强调一下xyz的顺序,从输入数据来看,读入的顺序是map[z][x][y] 总之,这是很基础的一道题 1 //#define LOCAL 2 #include <iostream> 3 #include <cstdio> 4 #include <cstring> 5 #include <queue> 6 #include <algorithm

HDU 1240 Asteroids!(BFS)

题目链接 Problem Description You're in space.You want to get home.There are asteroids.You don't want to hit them. Input Input to this problem will consist of a (non-empty) series of up to 100 data sets. Each data set will be formatted according to the fo

HDU 1240.Asteroids!

Asteroids! Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u SubmitStatusPracticeHDU 1240 Description You're in space. You want to get home. There are asteroids. You don't want to hit them. Input Input to this problem will

HDU 1240 Asteroids! 解题报告

//这道题做完我只有 三个感受  第一:坑: 第二 : 坑! 第三:还是坑! 咳咳  言归正传  WA了无数次之后才发现是输入进去时坐标时z, y, x的顺序输入的 题解   :  类似胜利大逃亡 只不过给你了起始坐标和终点坐标, 让你输出到达目标点所需最少步数: 输出时第一个输出时是START读入的map大小值n;第二个是所求步数 //细节: 1.读入:   读入时分别两次%S把没用的START 和 END读取掉: 2.输出时输出 三维坐标大小值n, 以及步数: 3.输入进去时开始点和结束点坐

HDU 2225 Asteroids!(三维BFS)

Asteroids! Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u Description You're in space. You want to get home. There are asteroids. You don't want to hit them. Input Input to this problem will consist of a (non-empty) seri

[ACM] hdu 1253 胜利大逃亡 (三维BFS)

胜利大逃亡 Problem Description Ignatius被魔王抓走了,有一天魔王出差去了,这可是Ignatius逃亡的好机会. 魔王住在一个城堡里,城堡是一个A*B*C的立方体,可以被表示成A个B*C的矩阵,刚开始Ignatius被关在(0,0,0)的位置,离开城堡的门在(A-1,B-1,C-1)的位置,现在知道魔王将在T分钟后回到城堡,Ignatius每分钟能从一个坐标走到相邻的六个坐标中的其中一个.现在给你城堡的地图,请你计算出Ignatius能否在魔王回来前离开城堡(只要走到出